INCDIR=include
CPPDIR=cpp
OBJDIR=cpp

SOURCES_BASE=\
  cpp/sbaes.cpp \
  cpp/sbalgorithmidentifier.cpp \
  cpp/sbapplecertstorage.cpp \
  cpp/sbapplecommon.cpp \
  cpp/sbbzip2.cpp \
  cpp/sbbzip2common.cpp \
  cpp/sbbzip2types.cpp \
  cpp/sbbzip2utils.cpp \
  cpp/sbbzlib.cpp \
  cpp/sbchacha20.cpp \
  cpp/sbconstants.cpp \
  cpp/sbcustomcrypto.cpp \
  cpp/sbdes.cpp \
  cpp/sbdsa.cpp \
  cpp/sbasn1.cpp \
  cpp/sbasn1tree.cpp \
  cpp/sbhashfunction.cpp \
  cpp/sbhmac.cpp \
  cpp/sbmath.cpp \
  cpp/sbmskeyblob.cpp \
  cpp/sbmd.cpp \
  cpp/sbpem.cpp \
  cpp/sbpoly1305.cpp \
  cpp/sbrandom.cpp \
  cpp/sbrc2.cpp \
  cpp/sbrc4.cpp \
  cpp/sbripemd.cpp \
  cpp/sbrsa.cpp \
  cpp/sbsha.cpp \
  cpp/sbsha2.cpp \
  cpp/sbtypes.cpp \
  cpp/sbutils.cpp \
  cpp/sbstrutils.cpp \
  cpp/sbstreams.cpp \
  cpp/sbencoding.cpp \
  cpp/sbblowfish.cpp \
  cpp/sbelgamal.cpp \
  cpp/sbcamellia.cpp \
  cpp/sbcast128.cpp \
  cpp/sbcrc.cpp \
  cpp/sblicensemanager.cpp \
  cpp/sbseed.cpp \
  cpp/sbrabbit.cpp \
  cpp/sbserpent.cpp \
  cpp/sbsharedresource.cpp \
  cpp/sbsocket.cpp \
  cpp/sbportknock.cpp \
  cpp/sbstringlist.cpp \
  cpp/sbtimer.cpp \
  cpp/sbtwofish.cpp \
  cpp/sbzuncompressunit.cpp \
  cpp/sbzlib.cpp \
  cpp/sbzcommonunit.cpp \
  cpp/sbzcompressunit.cpp \
  cpp/sbcryptoprov.cpp \
  cpp/sbcryptoprovutils.cpp \
  cpp/sbcryptoprovdefault.cpp \
  cpp/sbcryptoprovbuiltin.cpp \
  cpp/sbcryptoprovbuiltinhash.cpp \
  cpp/sbcryptoprovbuiltinpki.cpp \
  cpp/sbcryptoprovbuiltinsym.cpp \
  cpp/sbcryptoprovwin32.cpp \
  cpp/sbcryptoprovmanager.cpp \
  cpp/sbx509.cpp \
  cpp/sbx509ext.cpp \
  cpp/sbcrl.cpp \
  cpp/sbcrlstorage.cpp \
  cpp/sbcertretriever.cpp \
  cpp/sbcertvalidator.cpp \
  cpp/sbrdn.cpp \
  cpp/sbcustomcertstorage.cpp \
  cpp/sbmessages.cpp \
  cpp/sbpkcs5.cpp \
  cpp/sbpkcs7.cpp \
  cpp/sbpkcs7utils.cpp \
  cpp/sbpkcs8.cpp \
  cpp/sbpkcs12.cpp \
  cpp/sbjks.cpp \
  cpp/sbwincertstorage.cpp \
  cpp/sbwincrypt.cpp \
  cpp/sbsmimesignatures.cpp \
  cpp/sbocspcommon.cpp \
  cpp/sbocspclient.cpp \
  cpp/sbocspstorage.cpp \
  cpp/sbpublickeycrypto.cpp \
  cpp/sbsrp.cpp \
  cpp/sbsymmetriccrypto.cpp \
  cpp/sbpkiasync.cpp \
  cpp/sbtspcommon.cpp \
  cpp/sbtspclient.cpp \
  cpp/sbsockettspclient.cpp \
  cpp/sbtar.cpp \
  cpp/sbumac.cpp \
  cpp/sbeccommon.cpp \
  cpp/sbecmath.cpp \
  cpp/sbecdsa.cpp \
  cpp/sbgostcommon.cpp \
  cpp/sbgost341194.cpp \
  cpp/sbgost341094.cpp \
  cpp/sbgost341001.cpp \
  cpp/sbgost2814789.cpp \
  cpp/sbgssapi.cpp \
  cpp/sbgssapibase.cpp \
  cpp/sbgsswinauth.cpp \
  cpp/sbsspi.cpp \
  cpp/sbdnssec.cpp \
  cpp/sbdnssectypes.cpp \
  cpp/sbdnssecutils.cpp \
  cpp/sbcustomfsadapter.cpp \
  cpp/sbdiskfsadapter.cpp \
  cpp/sbpunycode.cpp \
  cpp/sbhttpauth.cpp \
  cpp/sbsasl.cpp \
  cpp/sbcomprstream.cpp \
  cpp/sbdc.cpp \
  cpp/sbdcdef.cpp \
  cpp/sbdcenc.cpp \
  cpp/csarmscii_8.cpp \
  cpp/csatarist.cpp \
  cpp/csbigfive.cpp \
  cpp/cscns_11643_1.cpp \
  cpp/cscns_11643_2.cpp \
  cpp/cscns_11643_3.cpp \
  cpp/cscns_11643_4.cpp \
  cpp/cscns_11643_5.cpp \
  cpp/cscns_11643_6.cpp \
  cpp/cscns_11643_7.cpp \
  cpp/cscns_11643_f.cpp \
  cpp/cscp1006.cpp \
  cpp/cscp1131.cpp \
  cpp/cscp1133.cpp \
  cpp/cscp1250.cpp \
  cpp/cscp1251.cpp \
  cpp/cscp1252.cpp \
  cpp/cscp1253.cpp \
  cpp/cscp1254.cpp \
  cpp/cscp1255.cpp \
  cpp/cscp1256.cpp \
  cpp/cscp1257.cpp \
  cpp/cscp1258.cpp \
  cpp/cscp037.cpp \
  cpp/cscp424.cpp \
  cpp/cscp437.cpp \
  cpp/cscp500.cpp \
  cpp/cscp737.cpp \
  cpp/cscp775.cpp \
  cpp/cscp850.cpp \
  cpp/cscp852.cpp \
  cpp/cscp853.cpp \
  cpp/cscp855.cpp \
  cpp/cscp856.cpp \
  cpp/cscp857.cpp \
  cpp/cscp860.cpp \
  cpp/cscp861.cpp \
  cpp/cscp862.cpp \
  cpp/cscp863.cpp \
  cpp/cscp864.cpp \
  cpp/cscp865.cpp \
  cpp/cscp866.cpp \
  cpp/cscp869.cpp \
  cpp/cscp874.cpp \
  cpp/cscp875.cpp \
  cpp/cscp950data.cpp \
  cpp/csgb_18030.cpp \
  cpp/csgb_2312.cpp \
  cpp/csgbk.cpp \
  cpp/csgeorgianacademy.cpp \
  cpp/csgeorgianps.cpp \
  cpp/csgeostd8.cpp \
  cpp/cshkscs.cpp \
  cpp/cshproman8.cpp \
  cpp/csiso_8859_10.cpp \
  cpp/csiso_8859_11.cpp \
  cpp/csiso_8859_13.cpp \
  cpp/csiso_8859_14.cpp \
  cpp/csiso_8859_15.cpp \
  cpp/csiso_8859_16.cpp \
  cpp/csiso_8859_2.cpp \
  cpp/csiso_8859_3.cpp \
  cpp/csiso_8859_4.cpp \
  cpp/csiso_8859_5.cpp \
  cpp/csiso_8859_6.cpp \
  cpp/csiso_8859_7.cpp \
  cpp/csiso_8859_8.cpp \
  cpp/csiso_8859_8i.cpp \
  cpp/csiso_8859_9.cpp \
  cpp/csiso_ir_165.cpp \
  cpp/csjis_0201.cpp \
  cpp/csjis_0208.cpp \
  cpp/csjis_0212.cpp \
  cpp/cskoi8r.cpp \
  cpp/cskoi8ru.cpp \
  cpp/cskoi8t.cpp \
  cpp/cskoi8u.cpp \
  cpp/csks_x_1001.cpp \
  cpp/csmacceltic.cpp \
  cpp/csmaccentraleuropean.cpp \
  cpp/csmaccroatian.cpp \
  cpp/csmaccyrillic.cpp \
  cpp/csmacgaelic.cpp \
  cpp/csmacgreek.cpp \
  cpp/csmachebrew.cpp \
  cpp/csmacicelandic.cpp \
  cpp/csmacroman.cpp \
  cpp/csmacromanian.cpp \
  cpp/csmacthai.cpp \
  cpp/csmacturkish.cpp \
  cpp/csnextstep.cpp \
  cpp/csshiftjis.cpp \
  cpp/csuhc.cpp \
  cpp/csviscii.cpp \
  cpp/sbchscjk.cpp \
  cpp/sbchsconv.cpp \
  cpp/sbchsconvbase.cpp \
  cpp/sbchsunicode.cpp \
  cpp/sbunicode.cpp \
  cpp/sbidea.cpp \
  cpp/sbcryptoprovbuiltinex.cpp \
  cpp/sbjson.cpp \
  cpp/sbbcrypt.cpp \
  cpp/sbwhirlpool.cpp \
  cpp/sbdictionary.cpp \
  cpp/sbusers.cpp 

SOURCES_CLOUD=\
  cpp/sbdatastorage.cpp \
  cpp/sbawsdatastorage.cpp \
  cpp/sbfiledatastorage.cpp \
  cpp/sbencstream.cpp \
  cpp/sbauthdatastream.cpp \
  cpp/sbwinazuredatastorage.cpp \
  cpp/sbgoogledatastorage.cpp \
  cpp/sbgoogledrivedatastorage.cpp \
  cpp/sbonedrivedatastorage.cpp \
  cpp/sbdropboxdatastorage.cpp \
  cpp/sbdatastorageencodings.cpp \
  cpp/sbdatastorageutils.cpp \
  cpp/sbboxdatastorage.cpp 

SOURCES_DAVCLI=\
  cpp/sbhttpswebdavclient.cpp \
  cpp/sbwebdavclient.cpp \
  cpp/sbwebdavcommon.cpp \
  cpp/sbvcard.cpp 

SOURCES_DAVSRV=\
  cpp/sbwebdavserver.cpp 

SOURCES_DC=\
  cpp/sbdcxmlenc.cpp \
  cpp/sbdcpki.cpp \
  cpp/sbdcserver.cpp 

SOURCES_EDI=\
  cpp/sbas2.cpp \
  cpp/sbas3.cpp \
  cpp/sbascommon.cpp \
  cpp/sbasutils.cpp 

SOURCES_FTPSCLI=\
  cpp/sbsimpleftps.cpp 

SOURCES_FTPSSRV=\
  cpp/sbftpscommon.cpp \
  cpp/sbftpsserver.cpp \
  cpp/sbsimpleftpsserver.cpp 

SOURCES_HTTPCLI=\
  cpp/sbhttpscommon.cpp \
  cpp/sbhttpsclient.cpp \
  cpp/sbhttptspclient.cpp \
  cpp/sbhttpocspclient.cpp \
  cpp/sbhttpcertretriever.cpp \
  cpp/sbhttpcrl.cpp \
  cpp/sboauth2.cpp \
  cpp/sbcookiemgr.cpp \
  cpp/sbwebsocketcommon.cpp \
  cpp/sbwebsocketclient.cpp \
  cpp/sbrestclient.cpp 

SOURCES_HTTPSRV=\
  cpp/sbhttpsserver.cpp \
  cpp/sbwebsocketserver.cpp 

SOURCES_LDAP=\
  cpp/sbldapcertstorage.cpp \
  cpp/sbldapcertretriever.cpp \
  cpp/sbldapcrl.cpp \
  cpp/sbldapsclient.cpp \
  cpp/sbldapscore.cpp 

SOURCES_MAIL=\
  cpp/sbsmtpclient.cpp \
  cpp/sbpop3client.cpp \
  cpp/sbimapclient.cpp \
  cpp/sbimaputils.cpp 

SOURCES_MIME=\
  cpp/sbdomainkeys.cpp \
  cpp/sbmime.cpp \
  cpp/sbmimeenc.cpp \
  cpp/sbmimestream.cpp \
  cpp/sbsimplemime.cpp 

SOURCES_OFFICE=\
  cpp/sbcompoundfile.cpp \
  cpp/sboffice.cpp \
  cpp/sbofficebinarycore.cpp \
  cpp/sbofficepackage.cpp \
  cpp/sbofficesecurity.cpp \
  cpp/sbofficexmlcore.cpp 

SOURCES_PDF=\
  cpp/sbpdf.cpp \
  cpp/sbpdfcore.cpp \
  cpp/sbpdfsecurity.cpp \
  cpp/sbpdfutils.cpp \
  cpp/sbpades.cpp 

SOURCES_PGP=\
  cpp/sbpgp.cpp \
  cpp/sbpgpentities.cpp \
  cpp/sbpgpkeys.cpp \
  cpp/sbpgpmd.cpp \
  cpp/sbpgpstreams.cpp \
  cpp/sbpgputils.cpp \
  cpp/sbpgpsfx.cpp 

SOURCES_PGPLDAP=\
  cpp/sbldapskeyserverclient.cpp 

SOURCES_PGPMIME=\
  cpp/sbpgpmime.cpp 

SOURCES_PGPSSH=\
  cpp/sbpgpssh.cpp 

SOURCES_PGPTLS=\
  cpp/sbpgptls.cpp 

SOURCES_PKI=\
  cpp/sbcms.cpp \
  cpp/sbcryptoprovpkcs11.cpp \
  cpp/sbpkcs11base.cpp \
  cpp/sbpkcs11manager.cpp \
  cpp/sbpkcs11certstorage.cpp \
  cpp/sbpkcs10.cpp \
  cpp/sbocspserver.cpp \
  cpp/sbtspserver.cpp \
  cpp/sbauthenticode.cpp \
  cpp/sbcrlex.cpp \
  cpp/sbx509ex.cpp \
  cpp/sbsshpkcs11keystorage.cpp \
  cpp/sbcades.cpp \
  cpp/sbcmc.cpp \
  cpp/sbotpcommon.cpp \
  cpp/sbotpclient.cpp \
  cpp/sbotpserver.cpp \
  cpp/sbeciescrypto.cpp 

SOURCES_SFTPCLI=\
  cpp/sbsftp.cpp \
  cpp/sbsftpcommon.cpp \
  cpp/sbsimplesftp.cpp 

SOURCES_SFTPSRV=\
  cpp/sbsftphandler.cpp \
  cpp/sbsftpserver.cpp \
  cpp/sbsimplesftpserver.cpp 

SOURCES_SMIME=\
  cpp/sbsmimecore.cpp \
  cpp/sbsmimecades.cpp 

SOURCES_SSHCLI=\
  cpp/sbsshconstants.cpp \
  cpp/sbsshkeystorage.cpp \
  cpp/sbsshterm.cpp \
  cpp/sbsshutils.cpp \
  cpp/sbsshclient.cpp \
  cpp/sbsshcommon.cpp \
  cpp/sbsimplessh.cpp \
  cpp/sbsshforwarding.cpp \
  cpp/sbsshpubkeycommon.cpp \
  cpp/sbsshpubkeyclient.cpp \
  cpp/sbsshauthagent.cpp 

SOURCES_SSHSRV=\
  cpp/sbsshserver.cpp \
  cpp/sbsshhandlers.cpp \
  cpp/sbsshconnectionhandler.cpp \
  cpp/sbsshpubkeyserver.cpp \
  cpp/sbsshpubkeyhandler.cpp \
  cpp/sbsimplesshserver.cpp \
  cpp/sbsshforwardinghandlers.cpp 

SOURCES_SSLCLI=\
  cpp/sbsslclient.cpp \
  cpp/sbsimplessl.cpp \
  cpp/sbsslcommon.cpp \
  cpp/sbcmdsslclient.cpp \
  cpp/sbdtlsclient.cpp 

SOURCES_SSLSRV=\
  cpp/sbsslserver.cpp \
  cpp/sbsessionpool.cpp \
  cpp/sbdtlsserver.cpp 

SOURCES_XML=\
  cpp/sbxmlcharsets.cpp \
  cpp/sbxmlcore.cpp \
  cpp/sbxmldefs.cpp \
  cpp/sbxmlpath.cpp \
  cpp/sbxmlutils.cpp 

SOURCES_XMLSEC=\
  cpp/sbxmlades.cpp \
  cpp/sbxmladesintf.cpp \
  cpp/sbxmlenc.cpp \
  cpp/sbxmlsec.cpp \
  cpp/sbxmlsig.cpp \
  cpp/sbxmltransform.cpp \
  cpp/sbxmlsoapcore.cpp \
  cpp/sbxmlwsscore.cpp \
  cpp/sbxmlsoap.cpp \
  cpp/sbxmlsoapsecurity.cpp 

SOURCES_SOAPCLI=\
  cpp/sbxmlsoapclient.cpp 

SOURCES_ZIP=\
  cpp/sbarcbase.cpp \
  cpp/sbarczip.cpp \
  cpp/sbzipentities.cpp \
  cpp/sbziputils.cpp \
  cpp/sbarctar.cpp \
  cpp/sbtarentities.cpp \
  cpp/sbtarutils.cpp \
  cpp/sbarcgzip.cpp \
  cpp/sbarcbzip2.cpp \
  cpp/sbzipsfx.cpp \
  cpp/sbzipsfxmaker.cpp 

SOURCES_SAML=\
  cpp/sbxmlsamlbind.cpp \
  cpp/sbxmlsamlcommon.cpp \
  cpp/sbxmlsamlcore.cpp \
  cpp/sbxmlsamlmetadata.cpp \
  cpp/sbxmlsamlprotocol.cpp \
  cpp/sbsamlidentityprovider.cpp \
  cpp/sbsamlserviceprovider.cpp 

SOURCES_DCPKI=\
  cpp/sbdccms.cpp 

SOURCES_CORE=\
  cpp/sbcore.cpp \
  cpp/sbmisc.cpp \
  cpp/sbsystem.cpp

SOURCES=$(SOURCES_BASE) $(SOURCES_CLOUD) $(SOURCES_DAVCLI) $(SOURCES_DAVSRV) $(SOURCES_DC) $(SOURCES_EDI) $(SOURCES_FTPSCLI) $(SOURCES_FTPSSRV) $(SOURCES_HTTPCLI) $(SOURCES_HTTPSRV) $(SOURCES_LDAP) $(SOURCES_MAIL) $(SOURCES_MIME) $(SOURCES_OFFICE) $(SOURCES_PDF) $(SOURCES_PGP) $(SOURCES_PGPLDAP) $(SOURCES_PGPMIME) $(SOURCES_PGPSSH) $(SOURCES_PGPTLS) $(SOURCES_PKI) $(SOURCES_SFTPCLI) $(SOURCES_SFTPSRV) $(SOURCES_SMIME) $(SOURCES_SSHCLI) $(SOURCES_SSHSRV) $(SOURCES_SSLCLI) $(SOURCES_SSLSRV) $(SOURCES_XML) $(SOURCES_XMLSEC) $(SOURCES_SOAPCLI) $(SOURCES_ZIP) $(SOURCES_SAML) $(SOURCES_DCPKI) $(SOURCES_CORE)
